{$I DacDemo.inc}

unit Cursor;

interface

uses
{$IFDEF MSWINDOWS}
  Windows, Messages,
{$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, ExtCtrls, Grids, DBGrids, StdCtrls, ToolWin, ComCtrls, Buttons,
{$IFNDEF FPC}
  MemDS,
{$ELSE}
  LResources,
  MemDataSet,
{$ENDIF}
  DB, DBAccess, Ora, OdacVcl, OdacDemoForm, DemoFrame;

type
  TCursorFrame = class(TDemoFrame)
    DBGrid: TDBGrid;
    DataSource: TDataSource;
    ToolBar: TPanel;
    Query: TOraQuery;
    OraSQL: TOraSQL;
    Panel1: TPanel;
    btOpen: TSpeedButton;
    btClose: TSpeedButton;
    DBNavigator: TDBNavigator;
    btGetCursor: TSpeedButton;
    procedure btOpenClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure btGetCursorClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure Initialize; override;
    procedure SetDebug(Value: boolean); override;
  end;

implementation
uses
  OraCall;

{$IFNDEF FPC}
{$R *.dfm}
{$ENDIF}

procedure TCursorFrame.btOpenClick(Sender: TObject);
begin
  Query.Open;
end;

procedure TCursorFrame.btCloseClick(Sender: TObject);
begin
  Query.Close;
end;
{
begin
  OPEN :Cur FOR
    SELECT D.*, D.RowId
    FROM Scott.Dept D;
end;
}
procedure TCursorFrame.btGetCursorClick(Sender: TObject);
begin
  Query.Close;
  OraSQL.Execute;
  Query.Cursor := OraSQL.ParamByName('Cur').AsCursor;
  Query.Open;
end;

procedure TCursorFrame.Initialize;
begin
  inherited;

  Query.Connection := Connection;
  OraSQL.Connection :=Connection;
end;

procedure TCursorFrame.SetDebug(Value: boolean);
begin
  Query.Debug := Value;
  OraSQL.Debug :=Value;
end;

initialization
{$IFDEF FPC}
{$I Cursor.lrs}
{$ENDIF}

end.
